# FilteredNormalizer2 Class Reference

Normalization filtered by a UnicodeSet. More...

`#include <normalizer2.h>`

Inheritance diagram for FilteredNormalizer2:

## Public Member Functions
| FilteredNormalizer2 (const Normalizer2 &n2, const UnicodeSet &filterSet)
| Constructs a filtered normalizer wrapping any Normalizer2 instance and a filter set.
virtual UnicodeString & | normalize (const UnicodeString &src, UnicodeString &dest, UErrorCode &errorCode) const
| Writes the normalized form of the source string to the destination string (replacing its contents) and returns the destination string.
virtual UnicodeString & | normalizeSecondAndAppend (UnicodeString &first, const UnicodeString &second, UErrorCode &errorCode) const
| Appends the normalized form of the second string to the first string (merging them at the boundary) and returns the first string.
virtual UnicodeString & | append (UnicodeString &first, const UnicodeString &second, UErrorCode &errorCode) const
| Appends the second string to the first string (merging them at the boundary) and returns the first string.
virtual UBool | isNormalized (const UnicodeString &s, UErrorCode &errorCode) const
| Tests if the string is normalized.
virtual UNormalizationCheckResult | quickCheck (const UnicodeString &s, UErrorCode &errorCode) const
| Tests if the string is normalized.
virtual int32_t | spanQuickCheckYes (const UnicodeString &s, UErrorCode &errorCode) const
| Returns the end of the normalized substring of the input string.
virtual UBool | hasBoundaryBefore (UChar32 c) const
| Tests if the character always has a normalization boundary before it, regardless of context.
virtual UBool | hasBoundaryAfter (UChar32 c) const
| Tests if the character always has a normalization boundary after it, regardless of context.
virtual UBool | isInert (UChar32 c) const
| Tests if the character is normalization-inert.
virtual UClassID | getDynamicClassID () const
| ICU "poor man's RTTI", returns a UClassID for the actual class.
## Static Public Member Functions
static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.

## Detailed Description

Normalization filtered by a UnicodeSet.

Normalizes portions of the text contained in the filter set and leaves portions not contained in the filter set unchanged. Filtering is done via UnicodeSet::span(..., USET_SPAN_SIMPLE). Not-in-the-filter text is treated as "is normalized" and "quick check yes". This class implements all of (and only) the Normalizer2 API. An instance of this class is unmodifiable/immutable but is constructed and must be destructed by the owner.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 308 of file normalizer2.h.

## Constructor & Destructor Documentation

FilteredNormalizer2::FilteredNormalizer2 | ( | const Normalizer2 & | n2,
|  | const UnicodeSet & | filterSet |
| ) |  |  | `[inline]`

Constructs a filtered normalizer wrapping any Normalizer2 instance and a filter set.

Both are aliased and must not be modified or deleted while this object is used. The filter set should be frozen; otherwise the performance will suffer greatly.

Parameters:

  | n2 | wrapped Normalizer2 instance
  | filterSet | UnicodeSet which determines the characters to be normalized

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 320 of file normalizer2.h.

## Member Function Documentation

virtual UnicodeString& FilteredNormalizer2::append | ( | UnicodeString & | first,
|  | const UnicodeString & | second,
|  | UErrorCode & | errorCode |
| ) |  |  | const`[virtual]`

Appends the second string to the first string (merging them at the boundary) and returns the first string.

The result is normalized if both the strings were normalized. The first and second strings must be different objects.

Parameters:

  | first | string, should be normalized
  | second | string, should be normalized
  | errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns:
  first

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UClassID FilteredNormalizer2::getDynamicClassID | ( |  | ) | const`[virtual]`

ICU "poor man's RTTI", returns a UClassID for the actual class.

Returns:
  a UClassID for the actual class.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

static UClassID FilteredNormalizer2::getStaticClassID | ( |  | ) | `[static]`

ICU "poor man's RTTI", returns a UClassID for this class.

Returns:
  a UClassID for this class.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Reimplemented from Normalizer2.

virtual UBool FilteredNormalizer2::hasBoundaryAfter | ( | UChar32 | c | ) | const`[virtual]`

Tests if the character always has a normalization boundary after it, regardless of context.

For details see the Normalizer2 base class documentation.

Parameters:

  | c | character to test

Returns:
  TRUE if c has a normalization boundary after it

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UBool FilteredNormalizer2::hasBoundaryBefore | ( | UChar32 | c | ) | const`[virtual]`

Tests if the character always has a normalization boundary before it, regardless of context.

For details see the Normalizer2 base class documentation.

Parameters:

  | c | character to test

Returns:
  TRUE if c has a normalization boundary before it

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UBool FilteredNormalizer2::isInert | ( | UChar32 | c | ) | const`[virtual]`

Tests if the character is normalization-inert.

For details see the Normalizer2 base class documentation.

Parameters:

  | c | character to test

Returns:
  TRUE if c is normalization-inert

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UBool FilteredNormalizer2::isNormalized | ( | const UnicodeString & | s,
|  | UErrorCode & | errorCode |
| ) |  |  | const`[virtual]`

Tests if the string is normalized.

For details see the Normalizer2 base class documentation.

Parameters:

  | s | input string
  | errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns:
  TRUE if s is normalized

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UnicodeString& FilteredNormalizer2::normalize | ( | const UnicodeString & | src,
|  | UnicodeString & | dest,
|  | UErrorCode & | errorCode |
| ) |  |  | const`[virtual]`

Writes the normalized form of the source string to the destination string (replacing its contents) and returns the destination string.

The source and destination strings must be different objects.

Parameters:

  | src | source string
  | dest | destination string; its contents is replaced with normalized src
  | errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns:
  dest

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UnicodeString& FilteredNormalizer2::normalizeSecondAndAppend | ( | UnicodeString & | first,
|  | const UnicodeString & | second,
|  | UErrorCode & | errorCode |
| ) |  |  | const`[virtual]`

Appends the normalized form of the second string to the first string (merging them at the boundary) and returns the first string.

The result is normalized if the first string was normalized. The first and second strings must be different objects.

Parameters:

  | first | string, should be normalized
  | second | string, will be normalized
  | errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns:
  first

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual UNormalizationCheckResult FilteredNormalizer2::quickCheck | ( | const UnicodeString & | s,
|  | UErrorCode & | errorCode |
| ) |  |  | const`[virtual]`

Tests if the string is normalized.

For details see the Normalizer2 base class documentation.

Parameters:

  | s | input string
  | errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns:
  UNormalizationCheckResult

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

virtual int32_t FilteredNormalizer2::spanQuickCheckYes | ( | const UnicodeString & | s,
|  | UErrorCode & | errorCode |
| ) |  |  | const`[virtual]`

Returns the end of the normalized substring of the input string.

For details see the Normalizer2 base class documentation.

Parameters:

  | s | input string
  | errorCode | Standard ICU error code. Its input value must pass the U_SUCCESS() test, or else the function returns immediately. Check for U_FAILURE() on output or use with function chaining. (See User Guide for details.)

Returns:
  "yes" span end index

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Implements Normalizer2.

The documentation for this class was generated from the following file:

- normalizer2.h

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Defines